﻿Broker_HealerCD = LibStub("AceAddon-3.0"):NewAddon("Broker_HealerCD", "AceEvent-3.0")
local ldb = LibStub:GetLibrary("LibDataBroker-1.1")
local QTC = LibStub('LibQTip-1.0')
local C = LibStub("AceConfigDialog-3.0")
local LGT = LibStub("LibGroupTalents-1.0")

local mod = Broker_HealerCD

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_HealerCD", "enUS", true)
	
if L then
	L["%s cast %s on %s!"] = true
	L["%s faded from %s!"] = true
	L["%s used %s!"] = true
	L["%s's %s consumed: %d heal!"] = true
	L["%s's %s faded from %s!"] = true
	L["|c000070ddClick:|r |c0000FF00Move up.\n|r|c000070ddRight-Click:|r |c0000FF00Move down.|r\n|c000070ddBroker-Click:|r |c0000FF00Spam heals.\n|r|c000070ddBroker-Shift-Click:|r |c0000FF00Toggle output.|r"] = true
	L["Assignment channel"] = true
	L["Channel to use for in combat notifications."] = true
	L["Combat output"] = true
	L["Combat spam channel"] = true
	L["Custom assignment channel"] = true
	L["Dev Mode"] = true
	L["Disabled: Not in a raid."] = true
	L["If this channel is blank then spam channel setting will be used."] = true
	L["Next %s CD: %s with %s!"] = true
	L["No Healers Found."] = true
	L["Options"] = true
	L["Raid cooldowns"] = true
	L["Tank cooldowns"] = true
	L["Tooltip hints"] = true
	L["Whisper healers"] = true
	L["Whisper to remind when time for their CD."] = true
	L["You have the next %s CD: %s!"] = true
end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_HealerCD", "koKR")
	
if L then
	
end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_HealerCD", "deDE")
	
if L then
	
end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_HealerCD", "esES")
	
if L then
	
end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_HealerCD", "frFR")
	
if L then
	
end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_HealerCD", "esMX")
	
if L then
	
end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_HealerCD", "ruRU")
	
if L then
	
end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_HealerCD", "zhCN")
	
if L then
	
end

local L = LibStub("AceLocale-3.0"):NewLocale("Broker_HealerCD", "zhTW")
	
if L then
	
end

local L = LibStub("AceLocale-3.0"):GetLocale("Broker_HealerCD")

local _G = _G
local db
local InstanceDiff
local format = string.format
local ISPROMOTED
local HEALERCDACTIVE
local Player = UnitName("player")
local tinsert = table.insert
local tremove = table.remove
local format = string.format
local find = string.find
local Spamchannels = {"RAID", "PARTY", "SAY"}
local Raidspamchannels = {"RAID_WARNING", "RAID", "PARTY", "SAY", "SELF"}
local HOS, tranq, hym, AM, painS, GS, PWB, SLT = GetSpellInfo(6940), GetSpellInfo(100855), GetSpellInfo(64843), GetSpellInfo(31821), GetSpellInfo(33206), GetSpellInfo(47788), GetSpellInfo(98888), GetSpellInfo(98008)
local spellIDconvert = {[HOS] = 6940, [tranq] = 100855, [hym] = 64843, [AM] = 31821, [painS] = 33206, [GS] = 47788, [PWB] = 98888, [SLT] = 98008}
local spellCDtimes = {[HOS] = 120, [tranq] = 480, [hym] = 480, [AM] = 120, [painS] = 180, [GS] = 180, [PWB] = 180, [SLT] = 180}
local playerCDranks = {}
local Healers = {}
local Tanks = {}
local HealCDUsers = {}
local PROMOTED
local SortedCDs = {tank = {}, raid = {}}
local sacrifice = {}
local versionstring = "r3"
local version = 3

local healerSpecs = {
	DRUID       = { false, false, true },
	PALADIN     = { true, false, false},
	PRIEST      = { true, true, false},	--disc, holy, ..
	SHAMAN      = { false, false, true},
}
local tankSpecs = {
	DRUID 		= { false, true, false },
	PALADIN     	= { false, true, false },
	WARRIOR      	= { false, false, true },	
	DEATHKNIGHT 	= { true, false, false},
}
local healerCDtalent = {
	DRUID       = {  },				
	PALADIN     = { 16 },				--AM
	PRIEST      = { [1] = {17, 21}, [2] = {21} },	--pain suppression, pw:barrier, guardian spirit
	SHAMAN      = { 17},				--spirit link totem
}
local healerCD = {
	DRUID       = { tranq },
	PALADIN     = { HOS },	--HOS
	PRIEST      = { hym},	
	SHAMAN      = { },
}
local tankCD = {
	DRUID       = {  },
	PALADIN     = { HOS },	--HOS
	PRIEST      = { painS, GS},	
	SHAMAN      = { },
}
local raidCD = {
	DRUID       = { tranq },
	PALADIN     = { AM },	
	PRIEST      = { hym, PWB},	
	SHAMAN      = { SLT },
}

--thanks to flump for CLE/spells
local spells = {
	-- Paladin
	[6940] 	= true,	-- Hand of Sacrifice
	[633] 	= true, -- Lay on Hands
	-- Priest
	[47788] = true, -- Guardian Spirit
	[33206] = true, -- Pain Suppression
}

local use = {
	-- Death Knight
	[48707] = true,	-- Anti-Magic Shell
	[48792] = true,	-- Icebound Fortitude
	[55233] = true,	-- Vampiric Blood
	-- Druid
	[22812] = true,	-- Barkskin
	[22842] = true,	-- Frenzied Regeneration
	[61336] = true,	-- Survival Instincts
	-- Paladin
	[31850] = true, -- Ardent Defender
	[498] 	= true, -- Divine Protection
	[86150] = true, -- Guardian of Ancient Kings
	-- Warrior
	[12975] = true,	-- Last Stand [SPELL_CAST_SUCCESS]
	[12976] = true,	-- Last Stand [SPELL_AURA_REMOVED]
	[871] 	= true,	-- Shield Wall
}

local other = {
	-- Paladin
	[70940] = true, -- Divine Guardian
	-- Warrior
	[97462] = true, -- Rallying Cry [SPELL_CAST_SUCCESS]
	[97463] = true, -- Rallying Cry [SPELL_AURA_REMOVED]
}

local special = {
	-- Druid
	[740] = true, 	-- Tranquility
	-- Paladin
	[31821] = true, -- Aura Mastery
	-- Priest
	[64843] = true, -- Divine Hymn
	[62618] = true, -- Power Word: Barrier
	-- Shaman
	[98008] = true, -- Spirit Link Totem
}

local defaults = {
	profile = {
		devmode = nil,
		channel = 1,
		textchannel = "",
		raidspam = 1,
		whisps = nil,
		output = true,
		showhint = true,
	}
}

local options = {
	name = "Broker HealerCD",
	handler = mod,
	type = "group",
	args = { 
		options = {
			name = L["Options"],
			handler = mod,
			type = "group",
			args = {
				dev = {
					type = "toggle",
					name = L["Dev Mode"],
					get = function() return mod.db.profile.devmode end,
					set = function(info, v) mod.db.profile.devmode = v end,
					order = 5
				},
				tool = {
					type = "toggle",
					name = L["Tooltip hints"],
					get = function() return mod.db.profile.showhint end,
					set = function(info, v) mod.db.profile.showhint = v end,
					order = 7
				},
				spamchan = {
					type = "select",
					name = L["Assignment channel"],
					get = function() return mod.db.profile.channel end,
					set = function(info, v) mod.db.profile.channel = v end,
					values = Spamchannels,
					disabled = function() return mod.db.profile.textchannel ~= "" end,
					order = 10
				},
				additem = {
					type = "input",
					name = L["Custom assignment channel"],
					desc = L["If this channel is blank then spam channel setting will be used."],
					get = function() return mod.db.profile.textchannel end,
					set = function(info, v) mod.db.profile.textchannel = v end,
					order = 15
				},
				output = {
					type = "toggle",
					name = L["Combat output"],
					get = function() return mod.db.profile.output end,
					set = function(info, v) mod.db.profile.output = v mod:ChangeIcon() end,
					order = 18
				},
				raidspam = {
					type = "select",
					name = L["Combat spam channel"],
					desc = L["Channel to use for in combat notifications."],
					get = function() return mod.db.profile.raidspam end,
					set = function(info, v) mod.db.profile.raidspam = v end,
					values = Raidspamchannels,
					order = 20
				},
				whisps = {
					type = "toggle",
					name = L["Whisper healers"],
					desc = L["Whisper to remind when time for their CD."],
					get = function() return mod.db.profile.whisps end,
					set = function(info, v) mod.db.profile.whisps = v end,
					order = 25
				},
			}
		}
	}
}
		
local function CopyTable(from, to)
	wipe(to)
	for index, data in pairs(from) do
		to[index] = data
	end
end

function mod:OnInitialize()
	if AddonLoader and AddonLoader.RemoveInterfaceOptions then
    		AddonLoader:RemoveInterfaceOptions("Broker_HealerCD")
	end
	self.db = LibStub("AceDB-3.0"):New("BrokerHealerCDDB", defaults)
	options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileReset", "OnProfileChanged")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Broker_HealerCD", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Broker_HealerCD", "Broker_HealerCD")
	self:CreateLDBObject()
end

function mod:OnEnable()
	db = mod.db.profile
	self.Ghost = nil
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	RegisterAddonMessagePrefix("HEALCD")
	self.Classcolors = {}
	self:ChangeIcon()
	self:SetupClasses()
	self:ZoneChange()
end

function mod:OnDisable()
	
end

function mod:OnProfileChanged()
	db = self.db.profile
end

function mod:PLAYER_ENTERING_WORLD()
	self:ZoneChange()
end

function mod:ZoneChange()
	local _, instanceType = IsInInstance()
	if UnitIsGhost("player") then self.Ghost = true return end
	if self.Ghost then self.Ghost = nil return end
	if instanceType == "raid" or self:InRaid() then self:Activatemod()
	else self:Deactivatemod()
	end
end

function mod:Activatemod()
	self:debug("Activate mod")
	HEALERCDACTIVE = true
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("RAID_ROSTER_UPDATE")
	self:RegisterEvent("CHAT_MSG_ADDON")
	LGT.RegisterCallback(self, "LibGroupTalents_Update", "OnTalentUpdate")
	LGT.RegisterCallback(self, "LibGroupTalents_Remove", "OnTalentRemove")
	LGT.RegisterCallback(self, "LibGroupTalents_Add", "OnTalentAdd")
	self:SendPing()
	self:AddPlayer()
end

function mod:Deactivatemod()
	HEALERCDACTIVE = nil
	self:debug("Deactivate mod")
	self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:UnregisterEvent("RAID_ROSTER_UPDATE")
	self:UnregisterEvent("CHAT_MSG_ADDON")
	LGT.UnregisterCallback(self, "LibGroupTalents_Update")
	LGT.UnregisterCallback(self, "LibGroupTalents_Remove")
	LGT.UnregisterCallback(self, "LibGroupTalents_Add")
end

function mod:SendPing()
	local prom = ""
	if PROMOTED then prom = " P" end
	SendAddonMessage("HEALCD", "CHECK "..version..prom, "RAID")
end
	
function mod:CHAT_MSG_ADDON(prefix, msg, channel, sender)
	if prefix ~= "HEALCD" or sender == Player then return end
	local _, _, command, data, promoted = find(msg, "(%w+)%s(%w+)%s(%w+)")
	if command == "CHECK" then
		tinsert(HealCDUsers, {n = sender, v = tonumber(data), p = true and promoted, status = true})
		self:DisableUsers()
	elseif command == "OFF" then
		self:Deactivatemod()
	end
end

function mod:DisableUsers()
	local candidate 
	for index, data in pairs(HealCDUsers) do
		if not data.p or data.p < version then data.status = false 
		elseif data.p and Healers[data.n] and data.status then candidate = index 
		end
	end
	if not candidate then SendAddonMessage("HEALCD", "OFF", "RAID")
	else
		if not PROMOTED then self:Deactivatemod() end
	end
end

function mod:RAID_ROSTER_UPDATE()
	if self:IsPromoted() or self:IsLeader() then PROMOTED = true
	else PROMOTED = nil end
end
	
function mod:COMBAT_LOG_EVENT_UNFILTERED(_, timestamp, event, hideCaster, srcGUID, srcName, srcFlags, srcRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellID, spellName, school, ...)
	if not UnitInRaid(srcName) then return end 
	if event == "SPELL_CAST_SUCCESS" then
		if spells[spellID] then
			self:Output(L["%s cast %s on %s!"]:format(srcName, GetSpellLink(spellID), destName)) -- [X] cast [Y] on [Z]
			if spellID ~= 633 and Healers[srcName] then Healers[srcName].tcd = time() end
		elseif use[spellID] and Tanks[srcName] then
			self:Output(L["%s used %s!"]:format(srcName, GetSpellLink(spellID))) -- [X] used [Y]
		elseif other[spellID] and Tanks[srcName] then
			self:Output(L["%s used %s!"]:format(srcName, GetSpellLink(spellID))) -- [X] used [Y] (other)
			sacrifice[srcGUID] = spellName
		elseif special[spellID] then -- Workaround for spells which aren't tanking spells
			self:Output(L["%s used %s!"]:format(srcName, GetSpellLink(spellID))) -- [X] used Aura Mastery
			if Healers[srcName] then 
				Healers[srcName].rcd = time() 
				if spellID == 98008 then self:CheckNextCDRaid(srcName) end	--hack for spirit link totem 
			end
		end
	elseif event == "SPELL_AURA_APPLIED" then -- [X] cast [Y] on [Z]
		if spellID == 1022 then
			self:Output(L["%s cast %s on %s!"]:format(srcName, GetSpellLink(spellID), destName)) -- [X] cast Hand of Protection on [Z]
		end
	elseif event == "SPELL_HEAL" then
		if spellID == 48153 or spellID == 66235 then -- Guardian Spirit / Ardent Defender
			local amount = ...
			self:Output(L["%s's %s consumed: %d heal!"]:format(srcName, GetSpellLink(spellID), amount)) -- [X]'s [Y] consumed: [Z] heal
			self:CheckNextCDTank(srcName)
		end
	elseif event == "SPELL_AURA_REMOVED" then
		if spells[spellID] or spellName == HOP then
			self:Output(L["%s's %s faded from %s!"]:format(srcName, GetSpellLink(spellID), destName)) -- [X]'s [Y] faded from [Z]
			if spellName ~= HOP and spellID ~= 633 then self:CheckNextCDTank(srcName) end
		elseif use[spellID] and Tanks[srcName] then
			self:Output(L["%s faded from %s!"]:format(GetSpellLink(spellID), srcName)) -- [X] faded from [Y]
		elseif other[spellID] and sacrifice[srcGUID] == spellName then
			self:Output(L["%s faded from %s!"]:format(GetSpellLink(spellID), srcName)) -- [X] faded from [Y] (other)
			sacrifice[srcGUID] = nil
		elseif special[spellID] then -- Workaround for spells which aren't tanking spells
			self:Output(L["%s faded from %s!"]:format(GetSpellLink(spellID), srcName)) -- Aura Mastery faded from [X]
			self:CheckNextCDRaid(srcName)
		end
	end
end

function mod:AddPlayer()
	local spec, spent1, spent2, spent3 = LGT:GetUnitTalentSpec("player")
	if spec then self:OnTalentUpdate("fake", _, "player", spec, spent1, spent2, spent3) end
end

function mod:OnTalentUpdate(event, guid, unit, spec, n1, n2, n3)
	self:debug("Event="..event.." GUID="..(guid or "NIL").." UNIT="..(unit or "NIL").." SPEC="..(spec or "NIL").." T1="..(n1 or "NIL").." T2="..(n2 or "NIL").." T3="..(n3 or "NIL"))
	local class = select (2, UnitClass(unit))
	local name = UnitName(unit)
	if not class or not UnitInRaid(unit) or not name then return end
	local tree = mod:GetDominantTree(n1, n2, n3)
	local ishealer
	if healerSpecs[class] then
		ishealer = healerSpecs[class][tree]
		if ishealer then self:AddHealer(unit, guid, class, spec, tree, name)
		else self:RemoveHealer(name)
		end
	end
	if not ishealer and tankSpecs[class] then
		local istank = tankSpecs[class][tree]
		if class == "DRUID" and istank then
			local role = LGT:GetUnitRole(unit)
			istank = istank and role == "tank"
		end
		if istank then 
			if not Tanks[name] then
				self:debug("Added tank: "..name)
				Tanks[name] = true
			end
		else 
			if Tanks[name] then
				self:debug("Removed tank: "..name)
				Tanks[name] = nil
			end
		end
	end
end

function mod:OnTalentRemove(event, guid, name, realm)
	self:debug("Event="..event.." GUID="..(guid or "NIL").." NAME="..(name or "NIL"))
	if name then
		if Healers[name] then self:RemoveHealer(name)
		elseif Tanks[name] then Tanks[name] = nil
		end
	end
end

function mod:OnTalentAdd(event, guid, name, realm)
	self:debug("Event="..event.." GUID="..(guid or "NIL").." NAME="..(name or "NIL"))
end

function mod:GetDominantTree(n1, n2, n3)
	return (n1 > n2 and n1 > n3 and 1) or (n2 > n1 and n2 > n3 and 2) or (n3 > n1 and n3 > n2 and 3) or 0
end

local tspells = {}
local rspells = {}
function mod:AddHealer(unit, guid, class, spec, tree, name)
	if not Healers[name] then
		wipe(tspells)
		wipe(rspells)
		local talenttable = healerCDtalent[class]
		if class == "PRIEST" then talenttable = talenttable[tree] end
		for index, talent in pairs(talenttable) do
			local talentName, _, _, _, currentRank = LGT:GetTalentInfo(unit, tree, talent)
			if currentRank > 0 then 
				if self:IsTankCD(talentName, class) then tinsert(tspells, talentName) 
				else tinsert(rspells, talentName) end
			end
		end
		for _, spell in pairs(healerCD[class]) do
			if self:IsTankCD(spell, class) then tinsert(tspells, spell) 
			else tinsert(rspells, spell) end
		end
		if class == "DRUID" then
			local talentName, _, _, _, currentRank = LGT:GetTalentInfo(unit, tree, 14)	--malfurion's gift
			if currentRank then
				if not playerCDranks[name] then playerCDranks[name] = {} end
				if currentRank == 1 then playerCDranks[name][tranq] = 300
				elseif currentRank == 2 then playerCDranks[name][tranq] = 180 end
			end
		end
		Healers[name] = {guid = guid, class = class, spec = spec, tree = tree, tspells = {}, rspells = {}, tcd = 0, rcd = 0}
		CopyTable(tspells, Healers[name].tspells)
		CopyTable(rspells, Healers[name].rspells)
		self:AddHealertoQ(name)
	end
end

function mod:CheckNextCDTank(name)
	local next = self:CDindex(name, "tank", "tcd")
	if next and SortedCDs.tank[next] then
		local name, spell = SortedCDs.tank[next].name, spellIDconvert[SortedCDs.tank[next].spell]
		self:Output(L["Next %s CD: %s with %s!"]:format("TANK", name, GetSpellLink(spell)))
		self:Whisper(name, spell, "TANK")
	end
end

function mod:CheckNextCDRaid(name)
	local next = self:CDindex(name, "raid", "rcd")
	if next and SortedCDs.raid[next] then
		local name, spell = SortedCDs.raid[next].name, spellIDconvert[SortedCDs.raid[next].spell]
		self:Output(L["Next %s CD: %s with %s!"]:format("RAID", name, GetSpellLink(spell)))
		self:Whisper(name, spell, "RAID")
	end
end

function mod:IsTankCD(spellname, class)
	for _, spell in pairs(tankCD[class]) do
		if spell == spellname then return true end
	end
end

function mod:SpellExists(healerindex, matchspell)
	for index, spell in pairs(Healers[healerindex].spells) do
		if spell == matchspell then return index end
	end
end

function mod:RemoveHealer(name)
	self:RemoveHealerFromQ(name)
	Healers[name] = nil
end

function mod:AddHealertoQ(name)
	for _, spell in pairs(Healers[name].tspells) do
		tinsert(SortedCDs.tank, {name = name, spell = spell})
	end
	for _, spell in pairs(Healers[name].rspells) do
		tinsert(SortedCDs.raid, {name = name, spell = spell})
	end
end

local temp = {}
function mod:RemoveHealerFromQ(name)
	wipe(temp)
	for _, data in ipairs(SortedCDs.tank) do
		if data.name ~= name then tinsert(temp, data) end
	end
	CopyTable(temp, SortedCDs.tank) 
	wipe(temp)
	for _, data in ipairs(SortedCDs.raid) do
		if data.name ~= name then tinsert(temp, data) end
	end
	CopyTable(temp, SortedCDs.raid) 
end

function mod:debug(message)
	if db.devmode then
		DEFAULT_CHAT_FRAME:AddMessage(message)
	end
end

function mod:SetupClasses()
	for class, color in pairs(CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS) do
		mod.Classcolors[class] = mod:GetClassHexColour(class)
	end
	if CUSTOM_CLASS_COLORS then
		CUSTOM_CLASS_COLORS:RegisterCallback(function()
        		for class, color in pairs(CUSTOM_CLASS_COLORS) do
               			mod.Classcolors[class] = mod:GetClassHexColour(class)
          		end
        	end)
	end
end

function mod:GetClassHexColour(class)
	if (CUSTOM_CLASS_COLORS and CUSTOM_CLASS_COLORS[class]) then
		return "|c00" .. string.format("%02x%02x%02x", CUSTOM_CLASS_COLORS[class].r*255, CUSTOM_CLASS_COLORS[class].g*255, CUSTOM_CLASS_COLORS[class].b*255)
	elseif (RAID_CLASS_COLORS and RAID_CLASS_COLORS[class]) then
		return "|c00" .. string.format("%02x%02x%02x", RAID_CLASS_COLORS[class].r*255, RAID_CLASS_COLORS[class].g*255, RAID_CLASS_COLORS[class].b*255)
	else
		return "a1a1a1"
	end
end

function mod:CreateLDBObject()
	mod.obj = ldb:NewDataObject("Broker_HealerCD", {type = "data source", icon = "Interface\\AddOns\\Broker_HealerCD\\Icons\\OutON"})
	mod.obj.OnClick = function(frame, button)
		if button == "RightButton" then
			if not C.OpenFrames["Broker_HealerCD"] then C:Open("Broker_HealerCD") 
			else C:Close("Broker_HealerCD") end
		else 
			if IsShiftKeyDown() then 
				mod.db.profile.output = not mod.db.profile.output
				mod:ChangeIcon()
			else mod:SpamChannel() end
		end
	end
	mod.obj.OnEnter = function(frame)
			if mod.tooltip then mod:HideTooltip() end
			local tooltip = QTC:Acquire("Broker_HealerCDTooltip", 4, "LEFT", "LEFT", "LEFT", "RIGHT")
			tooltip:Clear()
			tooltip:SmartAnchorTo(frame)
			tooltip:SetScript("OnLeave", mod.HideTooltip)
			tooltip:SetScript("OnUpdate", function(f) if not MouseIsOver(frame) then mod:HideTooltip() end end)
			mod.tooltip = tooltip
			mod:DisplayTooltip()
		end
	mod.obj.OnLeave = function()
		mod:HideTooltip()
	end
end

function mod:HideTooltip(force)
	if self.tooltip then
		if MouseIsOver(self.tooltip) and not force then return end
		self.tooltip:SetScript("OnLeave", nil)
		self.tooltip:SetScript("OnUpdate", nil)
		self.tooltip:Hide()
		QTC:Release(self.tooltip)
		self.tooltip = nil
	end
end

function mod:UpdateBrokerText()
	
end

function mod:ChangeIcon()
	if not mod.obj then return end
	if db.output then mod.obj.icon = "Interface\\AddOns\\Broker_HealerCD\\Icons\\OutON"
	else mod.obj.icon = "Interface\\AddOns\\Broker_HealerCD\\Icons\\OutOFF"
	end
end

function mod:InRaid()
	return UnitInRaid("player")
end

function mod:IsLeader()
	return IsRaidLeader()
end

function mod:IsPromoted()
	return IsRaidOfficer() 
end

function mod:DisplayTooltip()
	local tooltip = mod.tooltip
	if not tooltip then self:UpdateBrokerText() return end
	
	local tankheals, raidheals = #SortedCDs.tank, #SortedCDs.raid
	if tankheals > 0 or raidheals > 0 then
		local now = time()
		local sepadded
		if tankheals > 0 then
			tooltip:AddSeparator()
			sepadded = true
			local y, x = tooltip:AddLine()
			tooltip:SetCell(y, x, "|cFF00FFFF" .. L["Tank cooldowns"] .. "|r", nil, "LEFT", 4)
			for index, data in ipairs(SortedCDs.tank) do
				local cdtime = spellCDtimes[data.spell]
				if Healers[data.name].class == "DRUID" and data.spell == tranq and playerCDranks[data.name] and playerCDranks[data.name][tranq] then cdtime = playerCDranks[data.name][tranq] end
				local cdcolor = "|cff00ff00"
				local healercd = 0
				local lastcast = Healers[data.name].tcd
				if lastcast ~= 0 then healercd = cdtime - (now - lastcast) end
				if healercd > 0 then cdcolor = "|cffffff00" end
				local y, x = tooltip:AddLine(index .. ".", mod.Classcolors[Healers[data.name].class] .. data.name .. "|r", cdcolor .. data.spell .. "|r", (healercd > 0 and date("%M:%S", healercd)) or "")
				tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {data.name, "tank"})
			end
			tooltip:AddSeparator()
		end
		if raidheals > 0 then
			if not sepadded then tooltip:AddSeparator() end
			local y, x = tooltip:AddLine()
			tooltip:SetCell(y, x, "|cFF00FFFF" .. L["Raid cooldowns"] .. "|r", nil, "LEFT", 4)
			for index, data in ipairs(SortedCDs.raid) do
				local cdtime = spellCDtimes[data.spell]
				if Healers[data.name].class == "DRUID" and data.spell == tranq and playerCDranks[data.name] and playerCDranks[data.name][tranq] then cdtime = playerCDranks[data.name][tranq] end
				local cdcolor = "|cff00ff00"
				local healercd = 0
				local lastcast = Healers[data.name].rcd
				if lastcast ~= 0 then healercd = cdtime - (now - lastcast) end
				if healercd > 0 then cdcolor = "|cffffff00" end
				local y, x = tooltip:AddLine(index .. ".", mod.Classcolors[Healers[data.name].class] .. data.name .. "|r", cdcolor .. data.spell .. "|r", (healercd > 0 and date("%M:%S", healercd)) or "")
				tooltip:SetLineScript(y, "OnMouseDown", mod.HandleTTClick, {data.name, "raid"})
			end
			tooltip:AddSeparator()
		end
		if db.showhint then
			local line = tooltip:AddLine(" ")
			tooltip:SetCell(line, 1, L["|c000070ddClick:|r |c0000FF00Move up.\n|r|c000070ddRight-Click:|r |c0000FF00Move down.|r\n|c000070ddBroker-Click:|r |c0000FF00Spam heals.\n|r|c000070ddBroker-Shift-Click:|r |c0000FF00Toggle output.|r"], "CENTER", 4)   
		end
	else
		local y, x = tooltip:AddLine()
		if HEALERCDACTIVE then
			tooltip:SetCell(y, x, "|cFFFFFF00" .. L["No Healers Found."] .. "|r", nil, "LEFT", 4)
		else
			tooltip:SetCell(y, x, "|cFFFF0000" .. L["Disabled: Not in a raid."] .. "|r", nil, "LEFT", 4)
		end
	end
		 
        self:UpdateBrokerText()
	tooltip:Show()
end

function mod:HandleTTClick(data, button)
	if not data then return end
	local name = data[1]
	local cdtype = data[2]
	
	local healerindex = mod:CDindex(name, cdtype)
	local healermovevalue = SortedCDs[cdtype][healerindex]
	local numheals = #SortedCDs[cdtype]
	if numheals <= 1 then return end
	if button == "LeftButton" then		--move prio up
		tremove(SortedCDs[cdtype], healerindex)
		if healerindex == 1 then healerindex = numheals + 1 end
		tinsert(SortedCDs[cdtype], healerindex - 1, healermovevalue)
	elseif button == "RightButton" then	--move prio down
		tremove(SortedCDs[cdtype], healerindex)
		if healerindex == numheals then healerindex = 0 end
		tinsert(SortedCDs[cdtype], healerindex + 1, healermovevalue)
	end
      
        mod.tooltip:Clear()
	mod:DisplayTooltip()
end

function mod:CDindex(name, type, casttype)
	for index, data in pairs(SortedCDs[type]) do
		if data.name == name then
			if not casttype then return index end
			local now = time()
			--return index + 1
			local numcds = #SortedCDs[type]
			if index < numcds then 
				for i = index + 1, numcds do
					local data2 = SortedCDs[type][i]
					if not UnitIsDead(data2.name) and UnitIsConnected(data2.name) then
						local cdtime = spellCDtimes[data2.spell]
						if Healers[data2.name].class == "DRUID" and data2.spell == tranq and playerCDranks[data2.name] and playerCDranks[data2.name][tranq] then cdtime = playerCDranks[data2.name][tranq] end
						self:debug(i.."Name="..data2.name.." now=".. now .." - "..Healers[data2.name][casttype].." > "..cdtime)
						if now - Healers[data2.name][casttype] > cdtime then return i end
					end
				end
			end
			--didnt return so no cd found after player in list so try before
			if index ~= 1 then
				for i = 1, index - 1 do
					local data2 = SortedCDs[type][i]
					if not UnitIsDead(data2.name) and UnitIsConnected(data2.name) then
						local cdtime = spellCDtimes[data2.spell]
						if Healers[data2.name].class == "DRUID" and data2.spell == tranq and playerCDranks[data2.name] and playerCDranks[data2.name][data2.spell] then cdtime = playerCDranks[data2.name][data2.spell] end
						self:debug(i.."Name="..data2.name.." now=".. now .." - "..Healers[data2.name][casttype].." > "..cdtime)
						if now - Healers[data2.name][casttype] > cdtime then return i end
					end
				end
			end
			--no match found before or after so no match possible
			break
		end
	end
end

function mod:SpamChannel()
	local channel, id = Spamchannels[db.channel], nil
	if db.textchannel ~= "" then 
		channel = "CHANNEL"
		id = GetChannelName(db.textchannel) 
	end
	SendChatMessage(L["Tank cooldowns"], channel, nil, id)
	for index, data in ipairs(SortedCDs.tank) do
		local text = index .. ". " .. data.name .. " - " .. data.spell
		SendChatMessage(text, channel, nil, id)
	end
	SendChatMessage(L["Raid cooldowns"], channel, nil, id)
	for index, data in ipairs(SortedCDs.raid) do
		local text = index .. ". " .. data.name .. " - " .. data.spell
		SendChatMessage(text, channel, nil, id)
	end
end

function mod:Output(txt)
	if not db.output then return end
	if db.raidspam == 5 or (not self:InRaid() and (db.raidspam == 1 or db.raidspam == 2)) then
		print(txt)
	else
		local channel = Raidspamchannels[db.raidspam]
		if db.raidspam == 1 and not PROMOTED then channel = "RAID" end
		SendChatMessage(txt, channel)
	end
end

function mod:Whisper(name, spell, type)
	if not db.whisps then return end
	SendChatMessage(L["You have the next %s CD: %s!"]:format(type, GetSpellLink(spell)), "WHISPER", nil, name)
end

